import React, { useEffect, useState } from "react";
import { api } from "../API/API";
import { Project } from "../Types/goTypes";

const UserProjectListAdmin: React.FC = () => {
  const [projects, setProjects] = useState<Project[]>([]);

  useEffect(() => {
    const fetchProjects = async (): Promise<void> => {
      try {
        const token = localStorage.getItem("accessToken") ?? "";
        const username = "NoUser"; // getUsernameFromContext(); // Assuming you have a function to get the username from your context

        const response = await api.getUserProjects(username, token);
        if (response.success) {
          setProjects(response.data ?? []);
        } else {
          console.error("Failed to fetch projects:", response.message);
        }
      } catch (error) {
        console.error("Error fetching projects:", error);
      }
    };

    void fetchProjects();
  }, []);

  return (
    <div>
      <h2>User Projects</h2>
      <ul>
        {projects.map((project) => (
          <li key={project.id}>
            <span>{project.name}</span>
            {/* Add any additional project details you want to display */}
          </li>
        ))}
      </ul>
    </div>
  );
};

export default UserProjectListAdmin;
